;
; "Asm Instruction First byte Show" (Small disasm) (c) Reminder (1997)
;
 @dis_init:     lea    si,[bp+rle_table]         ; di - buf for table (256)
                mov    cx,88
                cld
 @c1:           lodsb
                mov    bx,1
                push   ax
                and    al,0F0h
                cmp    al,70h
                pop    ax
                jnz    @s1
                and    al,0fh
                mov    bl,al
                lodsb
                dec    cx
 @s1:           push   ax cx ax
                and    al,0fh
                stosb
                pop    ax
                mov    cx,4
                shr    al,cl
                stosb
                pop    cx ax
                dec    bx
                jnz    @s1
                loop   @c1
                ret
;
; Table 4 "Asm Instruction First byte Show" (Small disasm) (c) Reminder (1997)
;
;  11111111b
;  |   |
;  |   |
;  |   -  @1 (field 0 - 3 bit)			@1 - first byte
;  -  @2 (field 4-7 bit)			@2 - second  byte
;
; RLE Compression ;)
;if @2 = 0111b then next byte*@1
;
; (c) Reminder  (1997)
;
;	bp - ofsfet table si - kod.		si - next kod
;
 @dmain:        push   bx
                lodsb
;----------
                cmp    al,0fh
                jz     sux
                cmp    al,0f1h
                jz     sux
;----------
 cem_bp:        mov    bx,00ffh
                xlat
                sub    bx,bx

                or     al,al
                jz     quit
                push   ax         ; imm
                and    al,7
                add    bl,al
                pop    ax

                test   al,8               ;rm
                jz     quit
                lodsb
                mov    ah,al
                push   cx
                mov    cl,6
                shr    al,cl
                pop    cx
                cmp    al,3
                jz     quit
                add    bl,al
                or     al,al
                jnz    quit
                and    ah,7
                cmp    ah,6
                jnz    quit
                add    bx,2

 quit:          add    si,bx
                clc
                pop    bx
                ret

 sux:           stc
                pop    bx
                ret
;
 rle_table             db 088h,088h,021h,000h,088h,088h,021h,000h,088h,088h
                       db 021h,000h,088h,088h,021h,000h,088h,088h,021h,000h
                       db 088h,088h,021h,000h,088h,088h,021h,000h,088h,088h
                       db 021h,07Fh,000h,076h,000h,0A2h,091h,000h,000h,078h
                       db 011h,0A9h,0A9h,074h,088h,028h,088h,075h,000h,004h
                       db 000h,000h,022h,022h,000h,000h,022h,073h,000h,074h
                       db 011h,074h,022h,099h,002h,022h,0A9h,003h,002h,010h
                       db 000h,088h,088h,011h,000h,074h,088h,074h,011h,022h
                       db 014h,075h,000h,0A9h,073h,000h,088h
;
; start : si = location
; exit  : ax = size
;
 instr_size:    push   ax cx dx bx bp sp si di
                lea    di,[bp+sot]
                call   @dis_init
                pop    di si sp bp bx dx cx ax
                push   cx dx bx di si sp bp
                lea    cx,[bp+sot]
                mov    word ptr [bp+cem_bp+1],cx
                mov    cx,1
                xor    dx,dx
                mov    bx,si
                call   @dmain
                mov    ax,si
                sub    ax,bx
                pop    bp sp si di bx dx cx
                ret
;