;
; 楤 Kernel - ᮤন ࠡ稪 맮 㭪権  ᭮ 
; (c) ३ 䮭, Agafonov Andrew
;
; 砫 ࠡ        : 09 , 2000
; ᫥ 横: 09 , 2000
;
;
; kernel - 楤 ࠡ⪨  ࠬ஢
;
; on start ds:ax -  楤  맮
;
;
 kernel_ver             db 'KERNELx012'         ;  ୥
;
 kernel:        push    cx dx si
                mov     cx,2                    ; 㬭  㭪樨  2
                mul     cx                      ;  砥 ᬥ饭 
                                                ; 㭪樨  ⠡
                mov     si,offset proc_offsets
                add     si,ax
                mov     ax,word ptr [si]
                pop     si dx cx

                call    ax                      ; ᪠ 㭪
                ret
;
;  㭪権
;
 proc_offsets   label   byte
;
 _detect_use_string     dw offset string_det    ; 0
 _calculate_crc16       dw offset calculate_crc ; 1
 _detect_use_signature  dw offset sig_check     ; 2
 _cut_bytes_from_end    dw offset cut           ; 3
 _file_size_to_header   dw offset size_to_exehd ; 4
 _del_virus_from_start  dw offset cure_shift    ; 5
 _get_exe_entry_point   dw offset exe_entry     ; 6
 _get_com_entry_point   dw offset com_entry     ; 7
 _cure_hll_viruses      dw offset cure_transfer ; 8
 _delete_file           dw offset del_file      ; 9
 _det_use_ip_and_crc16  dw offset det_ip_n_crc  ; 10
 _det_use_crc16_only    dw offset det_crc16     ; 11
 _det_use_ip_and_sig    dw offset det_ip_n_sig  ; 12
 _det_vir_in_boot       dw offset det_boot_vir  ; 13
 _det_vir_in_mbr        dw offset det_mbr_vir   ; 14
 _cure_in_boot_n_mbr    dw offset cure_boot     ; 15
;
; ।⢥ ᠬ 㭪樨
;
; string_det - detect viruses (in batch, vbs...) using string crc16
;
; on start: ds:bx - file handle
;           ds:cx - number of strings to check
;           ds:di - crc16 for virus
;
 string_det:    call   calculate_ip
                sub    bp,offset string_det+3

                push   cx di

                mov    ax,4200h
                sub    cx,cx
                cwd
                int    21h

                mov    ah,3fh
                mov    cx,15000
                lea    dx,[bp+buffer]
                int    21h

                xchg   dx,si

                pop    di cx

 string_det_lp: cmp    byte ptr [si],"'"        ; if string is commented in VBS
                jz     cmntd_string

 check_rem:     push   di si cx                 ; if string is commented in BAT
                lea    di,[bp+rem_sig]
                mov    cx,3
                cld
                repe   cmpsb
                jz     cmntd_stringr
                pop    cx si di
               
                cmp    word ptr [di],0          ; if skip string
                jz     skip_string

                push   cx di
                call   work_string
                pop    di cx
                cmp    word ptr [di],ax
                jz     vbs_next_byte
                mov    ax,1
                ret

 vbs_next_byte: inc    di
                inc    di
                loop   string_det_lp

                sub    ax,ax
                ret

 rem_sig               db 'rem'

 skip_string:   inc    di
                inc    di
                dec    cx
                jmp    cmntd_string

 cmntd_stringr: pop    cx ax di

 cmntd_string:  push   cx
                mov    cx,550
 cmnt_str_loop: cmp    word ptr [si],0a0dh
                jnz    cmnt_str_lp

                inc    si
                inc    si
                pop    cx
                jmp    string_det_lp
               
 cmnt_str_lp:   inc    si
                loop   cmnt_str_loop
                pop    cx
                ret

; 塞 crc16 ப
 work_string:
;  cx (稪), si (砫 ப), si (砫 ப)
                push   si
; 塞 cx  ࠭ ࠧ ப  1310
                mov    cx,500
                sub    di,di
 vbs_srch_end:  cmp    word ptr [si],0a0dh      ; ᫨  1310,   -
                jz     found_end                ;  ப
                inc    si                       ; ᫨ , 㢥稬 ᨬ
                inc    di                       ; 㢥稬 ࠧ ப
                loop   vbs_srch_end             ; 饬  ப
                pop    si
                ret

 found_end:     inc    di                       ; 㢥稬 ࠧ ப (13)
                inc    di                       ; 㢥稬 ࠧ ப (10)
                pop    si                       ; ᯮ 砫 ப
                push   di
                call   calculate_crc            ; 塞 crc 16&32
                pop    di
                add    si,di
                ret
;
; calculate - calculate crc 16
;
; on start ds:si - data
;          ds:di - size of data
;
; return   ds:ax - crc16
;
 calculate_crc: cld
                push   cx dx bx si
                mov    cx,-1
                mov    dx,cx

 next_byte:     sub    ax,ax
                sub    bx,bx
                lodsb
                xor    al,cl
                mov    cl,ch
                mov    ch,dl
                mov    dl,dh
                mov    dh,8

 next_bit:      shr    bx,1
                rcr    ax,1
                jnc    no_carry
                xor    ax,8320h
                xor    bx,0edb8h

 no_carry:      dec    dh
                jnz    next_bit
                xor    cx,ax
                sub    dx,bx
                dec    di
                jnz    next_byte
                not    dx
                not    cx
                mov    ax,dx
                ror    ax,cl
                add    ax,cx
                pop    si bx dx cx
                ret
;
; sig_check - check signature
;
; on start ds:cx - signature size
;          ds:di - buffer location
;          ds:si - signature location
;
; return   ds:ax=0 when equails
;          ds:ax=1 when not
;
 sig_check:     mov    word ptr [bp+number_of_eq],0
                push   cx
 sig_check_lp:  cmp    byte ptr [si],'?'
                jnz    donot_skip

                push   cx
                sub    cx,cx
                mov    cl,byte ptr [si+1]
                add    di,cx
                pop    cx

                inc    si
                inc    si
                dec    cx
                dec    cx
                inc    word ptr [bp+number_of_eq]
                inc    word ptr [bp+number_of_eq]
                jmp    sig_check_lp

 donot_skip:    mov    al,byte ptr [di]
                cmp    byte ptr [si],al
                jnz    next_sig
                inc    word ptr [bp+number_of_eq]

 next_sig:      inc    si
                inc    di
                loop   sig_check_lp
                pop    cx

                cmp    word ptr [bp+number_of_eq],cx
                jnz    check_mod

                sub    ax,ax
                ret
                
 check_mod:     sub    cx,4
                cmp    word ptr [bp+number_of_eq],cx
                jnc    modific

 exit_sig:      mov    ax,1
                ret

 modific:       mov    ax,2
                ret

 number_of_eq          dw ?
;
; cut - cut cx bytes from end of file
;
; on start ds:cx - number of bytes to cut
;
 cut:           sub    dx,dx
                sub    dx,cx

                mov    ax,4202h
                mov    cx,0ffffh
                int    21h

                mov    ah,40h
                sub    cx,cx
                cwd
                int    21h
                ret
;
; size_to_exehd - write new file size to exe header (from offset three)
;
 size_to_exehd: mov    ax,4202h
                sub    cx,cx
                cwd
                int    21h

                push   ax
                add    ax,511
                shr    ax,9
                lea    si,[bp+buffer]
                mov    word ptr [si+2],ax
                pop    ax
                and    ax,511
                mov    word ptr [si],ax

                mov    ax,4200h
                sub    cx,cx
                mov    dx,2
                int    21h

                mov    ah,40h
                mov    cx,4
                xchg   si,dx
                int    21h
                ret
;
; cure_move - cure file infected by "Jerusalem" method
;
; on start ds:cx - size of virus
;
 cure_shift:    push   cx
                mov    word ptr [bp+read_pointer],cx
                mov    word ptr [bp+write_pointer],0
   
 move_cure_lp:  mov    ax,4200h
                sub    cx,cx
                mov    dx,word ptr [bp+read_pointer]
                int    21h

                mov    ah,3fh
                mov    cx,2000
                lea    dx,[bp+buffer]
                int    21h
                or     ax,ax
                jz     end_move_cr

                push   ax dx
                mov    ax,4200h
                sub    cx,cx
                mov    dx,word ptr [bp+write_pointer]                
                int    21h

                mov    ah,40h
                pop    dx cx
                int    21h
                add    word ptr [bp+read_pointer],cx
                add    word ptr [bp+write_pointer],cx
                jmp    move_cure_lp

 end_move_cr:   pop    cx
                call   cut

                sub    ax,ax
                ret
;
; exe_entry - get exe entry point in cx:dx
;
; on start ds:bx - file handle
;
; return   ds:cx - high ep
;          ds:dx - low  ep
;
 exe_entry:     mov     ax,4200h
                sub     cx,cx
                cwd
                int     21h

                mov     ah,3fh
                mov     cx,1ch
                lea     dx,[bp+buffer]
                int     21h

                mov     si,dx

                mov     ax,word ptr [si+16h]
                mov     cx,16
                mul     cx
                push    dx ax

                mov     ax,word ptr [si+8]
                mul     cx

                pop     cx
                add     ax,cx
                adc     dx,0
                pop     cx

                add     dx,cx
                add     ax,[si+14h]
                adc     dx,0
                mov     cx,dx
                xchg    dx,ax
                ret
;
; com_entry - get com entry point in cx:dx
;
; on start ds:bx - file handle
;
; return   ds:cx - 0
;          ds:dx - ep
;
 com_entry:     mov     ax,4200h
                sub     cx,cx
                cwd
                int     21h

                mov     ah,3fh
                mov     cx,3
                lea     dx,[bp+buffer]
                int     21h

                xchg    si,dx
                sub     cx,cx
                cmp     byte ptr [si],0e9h
                jz      calc_com_epnt
                sub     dx,dx
                ret

 calc_com_epnt: mov     dx,word ptr [si+1]
                add     dx,3
                ret
;
; cure_transfer - read cx bytes from end and write them to biginning
;
; on start ds:bx - file handle
;          ds:cx - virus size
;
 cure_transfer: push    cx
                mov     ax,4202h
                sub     cx,cx
                cwd
                int     21h
                pop     cx 

                cmp     cx,ax
                jg      only_transfer
                
                lea     cx,[bp+file_name]
                call    del_file
                sub     ax,ax
                ret

 only_transfer: push    cx
                mov     ax,4202h
                cwd
                sub     dx,cx
                mov     cx,0ffffh
                int     21h

                mov     ah,3fh
                pop     cx
                lea     dx,[bp+buffer]
                int     21h
                push    ax
                xchg    ax,cx
                call    cut

                mov     ax,4200h
                sub     cx,cx
                cwd
                int     21h

                mov     ah,40h
                pop     cx
                lea     dx,[bp+buffer]
                int     21h

                sub     ax,ax
                ret
;
; del_file - delete file
;
; on start ds:cx - file name to delete (in ASCII)
;
; return   ds:ax=0 and ds:cx=1982 if file succesfuly deleted
;          ds:ax=1 if error occured
;
 del_file:      mov    ax,4300h
                xchg   dx,cx
                int    21h
                jc     del_file_er

                mov    ax,4301h
                sub    cx,cx
                int    21h
                jc     del_file_er
          
                mov    ah,41h
                int    21h
                jc     del_file_er

                sub    ax,ax
                mov    cx,1982
                ret

 del_file_er:   mov    ax,1
                ret
;
; det_ip_n_crc - calculate crc16 of cx bytes from exe entry point
;
; on start ds:cx - bytes to calculate
;          ds:dx - viral crc16
;
; return   ds:ax=0 if crc16 not equail
;          ds:ax=1 if crc16 equail
;
 det_ip_n_crc:  call    calculate_ip
                sub     bp,offset det_ip_n_crc+3

                push    dx cx
                call    exe_entry

                mov     ax,4200h
                int     21h
 _read_file:    pop     cx

                mov     ah,3fh
                lea     dx,[bp+buffer]
                int     21h

                xchg    di,ax
                xchg    si,dx
                call    calculate_crc
                pop     dx
                cmp     ax,dx
                jz      crc_equail

                mov     ax,1
                ret

 crc_equail:    sub     ax,ax
                ret
;
; det_crc16 - calculate crc16 of cx bytes from current pointer location
;
; on start ds:cx - bytes to calculate
;          ds:dx - viral crc16
;
; return   ds:ax=0 if crc16 not equail
;          ds:ax=1 if crc16 equail
;
 det_crc16:     push    dx cx
                sub     cx,cx
                cwd 
                jmp    _read_file
;
; det_ip_n_sig - check signature from com or exe entry point
;
; on start ds:cx - signature size
;          ds:si - signature location
;
; return   ds:ax=0 if signature not equail
;          ds:ax=1 if signature equail
;
 det_ip_n_sig:  call    calculate_ip
                sub     bp,offset det_ip_n_sig+3

                push    cx si

                mov     ax,4200h
                sub     cx,cx
                cwd
                int     21h

                mov     ah,3fh
                mov     cx,2
                lea     dx,[bp+buffer]
                int     21h

                cmp     word ptr [bp+buffer],'MZ'
                jz      sig_get_exeip
 check_zm:      cmp     word ptr [bp+buffer],'ZM'
                jz      sig_get_exeip

 sig_get_comip: call    com_entry
                jmp     sig_seekto_ip

 sig_get_exeip: call    exe_entry

 sig_seekto_ip: mov     ax,4200h
                int     21h

                mov     ah,3fh
                mov     cx,5000
                lea     dx,[bp+buffer]
                int     21h

                xchg    dx,di
                pop     si cx
                call    sig_check
                ret
;
; det_boot_vir - det virus in boot
;
; on start ds:cx - signature size
;          ds:dh - number of sectors to read
;          ds:dl - drive (80h - hdd)
;          ds:di - offset
;          ds:si - signature location
;
; return   ds:ax=0 if signature not equail
;          ds:ax=1 if signature equail
;
 det_boot_vir:  call   calculate_ip
                sub    bp,offset det_boot_vir+3

                mov    ah,19h
                int    21h
                mov    dl,al

                cmp    dl,2
                jl     its_a_floppy

                mov    ax,1
;               sub    ax,ax
                ret

 its_a_floppy:  mov    al,dh
                sub    dh,dh

                push   bx cx
                mov    ah,2
                mov    cx,1
                lea    bx,[bp+buffer]
                add    di,bx
                int    13h

                pop    cx bx
                call   sig_check

                ret
;
; det_mbr_vir - det virus in mbr
;
; on start ds:cx - signature size
;          ds:dh - number of sectors to read
;          ds:di - offset
;          ds:si - signature location
;
; return   ds:ax=0 if signature not equail
;          ds:ax=1 if signature equail
;
 det_mbr_vir:   call   calculate_ip
                sub    bp,offset det_mbr_vir+3

                mov    ah,19h
                int    21h
                mov    dl,al

                cmp    dl,2
                jnb    its_a_hdd
 
 its_a_hdd:     add    dl,07eh

                mov    al,dh
                sub    dh,dh

                push   bx cx
                mov    ah,2
                mov    cx,1
                lea    bx,[bp+buffer]
                add    di,bx
                int    13h

                pop    cx bx
                call   sig_check

                ret
;
; cure_boot - cure virus in boot
;
; on start ds:ch - cylinder
;          ds:cl - sector
;          ds:si - number of sectors to read
;          ds:dh - head
;
; return   ds:ax=0 if signature not equail
;          ds:ax=1 if signature equail
;
 cure_boot:     call   calculate_ip
                sub    bp,offset cure_boot+3

                mov    ah,19h
                int    21h
                mov    dl,al

                cmp    dl,2
                jl     _its_a_floppy

 _its_a_hdd:    add    si,07eh

 _its_a_floppy: mov    ax,si

                mov    ah,2
                lea    bx,[bp+buffer]
                int    13h

                mov    ah,3
                int    13h

                sub    ax,ax
                ret
;
;