                                                                      comment ~

                         the Sweeper procedures library
                      (c) 2000 C. Thomas Hawell Computing

 
                                                                              ~
 current               equ 12
 black                 equ 0
 blue                  equ 1
 green                 equ 2
 cyan                  equ 3
 red                   equ 4
 magenta               equ 5
 korichneviy           equ 6
 gray                  equ 7
 dark_gray             equ 8
 light_blue            equ 9
 light_green           equ 10
 light_cyan            equ 11
 light_red             equ 12
;
 read_language: mov     ax,3d00h
                lea     dx,[bp+sweeper_lng]
                int     21h
                xchg    bx,ax
                jnc     read_lng_file

                lea     si,[bp+no_language]
                call    print_string

                mov     ax,4c00h
                int     21h

 read_lng_file: mov     ah,3fh
                mov     cx,1000
                lea     dx,[bp+language]
                int     21h
                push    ax

                mov     ah,3eh
                int     21h

                pop     cx
                mov     ax,word ptr [bp+language]
                lea     si,[bp+language+2]
                call    decrypt_code

                lea     si,[bp+swpr_version]
                lea     di,[bp+language+2]
                mov     cx,3
                cld
                repe    cmpsb
                jz      lng_id_okey

                mov     ax,4c00h
                int     21h

 lng_id_okey:   ret
;
 decrypt_code:  xor     byte ptr [si],al
                dec     al
                xor     byte ptr [si],ah
                inc     ah
                inc     si
                loop    decrypt_code
                ret
;
 restore_attr:  mov     ax,4301h
                mov     cx,word ptr [bp+temp_attr]
                lea     dx,[bp+file_name]
                int     21h
                ret
;
 save_attr:     mov     ax,4300h
                lea     dx,[bp+file_name]
                int     21h
                mov     word ptr [bp+temp_attr],cx

                mov     ax,4301h
                sub     cx,cx
                lea     dx,[bp+file_name]
                int     21h
                ret
;
; report - 뢮  ࠭ ( 뢠  䠩 , ᫨ 㦭)  
;          ஢થ
;
 report:        cmp     word ptr [bp+scanned],0 ; ᫨   䠩  -
                jnz     show_report             ; ७,  ... 
                ret                             ; 뢥 
;
 show_report:   lea     di,[bp+end_time]        ; ࠭ ६  ᪠-
                call    save_time               ;  "end_time"

                lea     si,[bp+language]
                add     si,[bp+msg_scanned]
                call    print_string
                mov     dx,word ptr [bp+scanned]
                call   _dec16out
                call    show_nul

                lea     si,[bp+language]
                add     si,[bp+msg_infected]
                call    print_string
                mov     dx,word ptr [bp+infected]
                call   _dec16out
                call    show_nul

                lea     si,[bp+language]
                add     si,[bp+msg_mod]
                call    print_string
                mov     dx,word ptr [bp+possibly]
                call   _dec16out
                call    show_nul

                lea     si,[bp+language]
                add     si,[bp+msg_cleaned]
                call    print_string
                mov     dx,word ptr [bp+cleaned]
                call   _dec16out
                call    show_nul

                lea     si,[bp+language]
                add     si,[bp+msg_deleted]
                call    print_string
                mov     dx,word ptr [bp+deleted]
                call   _dec16out
                call    show_nul
;
 show_time_msg: lea     si,[bp+language]        ; 뢮 ଠ  ६
                add     si,[bp+msg_time]        ; 祭  ஢
                call    print_string

                sub     dx,dx
                mov     dl,byte ptr [bp+end_time]
                sub     dl,byte ptr [bp+start_time]
                call   _dec16out
                mov     al,':'
                call    display_l

                sub     dx,dx
                mov     dl,byte ptr [bp+end_time+1]
                sub     dl,byte ptr [bp+start_time+1]
                call   _dec16out
                mov     al,':'
                call    display_l

                sub     dx,dx
                mov     dl,byte ptr [bp+end_time+2]
                sub     dl,byte ptr [bp+start_time+2]
                call   _dec16out
                call    show_nul
                ret
;
; save_time - ࠭塞   di ⥪饥 ६ (::)
;
 save_time:     mov     ah,2ch
                int     21h

                xchg    al,ch                   ; al - ⥪饥 祭 
                stosb                           ; 㥬  [di]
                xchg    al,cl                   ; al - ⥪饥 祭 
                stosb                           ; 㥬  [di]
                xchg    al,dh                   ; al - ⥪饥 祭 ᥪ㭤
                stosb                           ; 㥬  [di]
                ret
;
 set_dir:       mov     ah,0eh
                mov     dl,byte ptr [si]
                sub     dl,61h
                int     21h

                mov     ah,3bh
                lea     dx,[si]
                int     21h
                ret
;
 calculate_ip:  pop     bp
                push    bp
                ret
;
; print_string - display string on screen and write it to report file
;
; on start  ds:si - string (must end with zero)
;
 print_string:  push    si                      ; save si
;
 move_loop:     lodsb                           ; byte to al
                or      al,al
                jz      stdisplay_end           ; if al==0 then string is end
                call    display_l               ; display letter
                jmp     move_loop
;
 stdisplay_end: pop     si                      ; restore si
                ret                             ; exit, if string end
;
; goto_xy - move cursor to X,Y
;
; on start  ds:dh - x
;           ds:dl - y
;
 goto_xy:       mov     ah,2
                mov     bh,0
                int     10h
                ret
;
; get_xy - gets curent cursor position
;
; on start  ds:dh - x
;           ds:dl - y
;
 get_xy:        mov     ah,3
                mov     bh,0
                int     10h
                ret
;
; xy_to_di - coordinates from dx to di
;
; on start  ds:dh - x
;           ds:dl - y
;
; on exit   ds:di - coordinates
;
 xy_to_di:      sub     di,di
                sub     ax,ax
                mov     al,dl
                push    dx
                mov     cx,160
                mul     cx
                pop     dx
                add     di,ax                   ; x coordinate in di

                sub     ax,ax
                mov     al,dh
                push    dx
                mov     cx,2
                mul     cx
                pop     dx
                add     di,ax                   ; y coordinate in di
                ret
;
