 model  tiny
 assume cs:@code, ds:@data
 codeseg

 entry_size     equ     25

 start:         mov     ax,@data
                mov     ds,ax

                call    get_ip
 get_ip:        pop     bp
                sub     bp,offset get_ip

                lea     si,[bp+info]
                call    print_string

 ly_o_n:        sub     ax,ax
                int     16h
                cmp     al,'R'
                jz      russian
                cmp     al,'r'
                jz      russian
                cmp     al,'E'
                jz      english
                cmp     al,'e'
                jz      english
                jmp     ly_o_n

 russian:       lea     dx,[bp+russian_dat]
                jmp     move_file
 english:       lea     dx,[bp+english_dat]

 move_file:     push    dx
                mov     ax,4300h
                lea     dx,[bp+sweeper_lng]
                int     21h
                jc      del_file_er

                mov     ax,4301h
                sub     cx,cx
                int     21h
                jc      del_file_er

                mov     ah,41h
                int     21h
                jc      del_file_er

 del_file_er:   pop     dx
                mov     ax,3d00h
                int     21h
                jnc     read_lng

                lea     si,[bp+error_language]
                call    print_string

                mov     ax,4c00h
                int     21h

 read_lng:      xchg    bx,ax
                mov     ah,3fh
                mov     cx,1000
                lea     dx,[bp+buffer]
                int     21h
                push    ax

                mov     ah,3eh
                int     21h

                mov     ah,3ch
                sub     cx,cx
                lea     dx,[bp+sweeper_lng]
                int     21h
                xchg    bx,ax

                mov     ah,40h
                pop     cx
                lea     dx,[bp+buffer]
                int     21h

                mov     ah,3eh
                int     21h

                call    show_nul

 choose_c_o_s:  lea     si,[bp+cure_or_scan]
                call    print_string

 y_o_n:         sub     ax,ax
                int     16h
                cmp     al,'c'
                jz      cure
                cmp     al,'C'
                jz      cure
                cmp     al,'s'
                jz      scan
                cmp     al,'S'
                jz      scan
                jmp     y_o_n

 cure:          mov     byte ptr [bp+scan_o_cure],000h
                jmp     choose_ds
 scan:          mov     byte ptr [bp+scan_o_cure],001h

 choose_ds:     call    show_nul
                lea     si,[bp+deep_virus_scan]
                call    print_string

 dy_o_n:        sub     ax,ax
                int     16h
                cmp     al,'y'
                jz      deep
                cmp     al,'Y'
                jz      deep
                cmp     al,'n'
                jz      not_deep
                cmp     al,'N'
                jz      not_deep
                jmp     dy_o_n

 deep:          mov     byte ptr [bp+deep_scan],000h
                jmp     report
 not_deep:      mov     byte ptr [bp+deep_scan],001h

 report:        call    show_nul
                lea     si,[bp+msg_report]
                call    print_string

 ry_o_n:        sub     ax,ax
                int     16h
                cmp     al,'y'
                jz      create_r
                cmp     al,'Y'
                jz      create_r
                cmp     al,'n'
                jz      ncreate_r
                cmp     al,'N'
                jz      ncreate_r
                jmp     ry_o_n

 ncreate_r:     mov     byte ptr [bp+report_],000h
                jmp     write
 create_r:      mov     byte ptr [bp+report_],001h

                call    show_nul
                lea     si,[bp+msg_report_how]
                call    print_string

 ra_o_r:        sub     ax,ax
                int     16h
                cmp     al,'r'
                jz      recreate
                cmp     al,'R'
                jz      recreate
                cmp     al,'a'
                jz      addtoexist
                cmp     al,'A'
                jz      addtoexist
                jmp     ra_o_r

 recreate:      mov     byte ptr [bp+report_how],000h
                jmp     report_name
 addtoexist:    mov     byte ptr [bp+report_how],001h

 report_name:   call    show_nul
                lea     si,[bp+msg_report_fname]
                call    print_string

                lea     si,[bp+report_fname]
                call    keyp

 write:         mov     ah,3ch
                sub     cx,cx
                lea     dx,[bp+sweeper_cfg]
                int     21h
                xchg    bx,ax

                mov     ah,40h
                mov     cx,(config_end-config_start)
                lea     dx,[bp+config_start]
                int     21h

                mov     ah,3eh
                int     21h

 exit_to_dos:   mov     ax,4c00h
                int     21h
;
; print_string - display string on screen (string must end with zero)
;
 print_string:  push    si
 move_loop:     lodsb
                or      al,al
                jz      displayed
                int     29h
                jmp     move_loop
 displayed:     pop     si
                retn
;
; show_nul - next string
;
 show_nul:      push    ax
                mov     ax,0e0dh
                int     10h
                mov     ax,0e0ah
                int     10h
                pop     ax
                ret
;
 keyp:          mov     ah,01h                  ; Get keypress
                int     21h
                cmp     al,13                   ; Is it a CR?
                je      exit_key                ; Yes? Quit
                cmp     al,8
                je      dec_si
                mov     [si],al                 ; No? Store the keypress
                inc     cx
                inc     si
                jmp     keyp

 dec_si:        dec     si
                jmp     keyp

 exit_key:      ret
;
; data segment
;
 dataseg
 sweeper_cfg            db 'sweeper.cfg',0
 sweeper_lng            db 'sweeper.lng',0
 english_dat            db 'english.dat',0
 russian_dat            db 'russian.dat',0
 info                   db 'the Sweeper 012/beta for dos Setup',13,10
 choose_language        db 'What language do you prefer [Russian/English]? ',0
 cure_or_scan           db 'Scan and cure infected files or scan only [S/C]? ',0
 deep_virus_scan        db 'Deep virus scan [Y/N]? ',0
 msg_report             db 'Create report file [Y/N]? ',0
 msg_report_how         db 'Re-create report file or add to existing [A/R]? ',0
 msg_report_fname       db 'Enter report file name: ',0
 error_language         db 13,10,'Put files "RUSSIAN.DAT" and "ENGLISH.DAT" in the Sweeper directory',0
 config_start   label   byte
 scan_o_cure            db ?
 deep_scan              db ?
 report_                db ?
 report_how             db ?
 report_fname           db 13 dup (0)
 config_end     label   byte
 buffer         label   byte
;
                end     start