 model  tiny
.386
 assume cs:@code, ds:@data
 codeseg

 entry_size     equ     25

 start:         mov     ax,@data
                mov     ds,ax
                mov     es,ax

 av_start:      call    calculate_ip
                sub     bp,offset av_start+3
comment *
int 3
                mov     dx,21a0h
                mov     cx,((code_end-code)-10)
                lea     si,[bp+code]
                call    emulate
int 3

 code:                  db 0BEh,0AFh,021h,0B9h,005h,000h,026h,081h,034h,02Bh
                        db 0B0h,046h,046h,0E2h,0F7h
 crypted                db 0A7h,078h,016h,0B0h,02Bh,0C4h,00Ah,00Fh,02Bh,0B1h
 code_end       label   byte
*
                lea     di,[bp+start_time]      ; ࠭ ६ 砫 ᪠-
                call    save_time               ; ஢  "start_time"

                mov     word ptr [bp+original_path+1],'\:'

                call    read_language

                mov     ah,62h
                int     21h

                push    es ds
                mov     ax,@data
                mov     es,ax
                mov     ds,bx
                mov     si,82h
                cmp     byte ptr [si],0
                jz      cmnd_line_er

                lea     di,[bp+command_line]
                mov     cx,100
                cld
                rep     movsb
                pop     ds es
                jmp     load_cfg

 cmnd_line_er:  pop     ds es
                call    display_info
                lea     si,[bp+language]
                add     si,[bp+msg_command_parameters]
                call    print_string
                jmp     end_of_work

 load_cfg:      mov     ax,3d02h
                lea     dx,[bp+cfg_name]
                int     21h
                jnc     cfg_handle

 cfg_not_fnd:   lea     si,[bp+language]
                add     si,word ptr [bp+msg_cfg_not_fnd]
                call    print_string
                jmp     end_of_work

 cfg_handle:    xchg    bx,ax

                mov     ah,3fh
                mov     cx,(cfg_end-cfg_start)
                lea     dx,[bp+cfg_start]
                int     21h

                mov     ah,3eh
                int     21h

                cmp     byte ptr [bp+report_q],001h
                jnz     load_base

                cmp     byte ptr [bp+report_how],001h
                jnz     create_rep

                mov     ax,3d02h
                lea     dx,[bp+report_fname]
                int     21h
                mov     word ptr [bp+report_handle],ax
                jc      create_rep
                xchg    bx,ax

                mov     ax,4202h
                sub     cx,cx
                cwd
                int     21h
                jmp     load_base

 create_rep:    mov     ah,3ch
                sub     cx,cx
                lea     dx,[bp+report_fname]
                int     21h
                jnc     _handle_rep
                mov     byte ptr [bp+report_q],000h
                jmp     load_base
 _handle_rep:   mov     word ptr [bp+report_handle],ax

 load_base:     call    display_info

                mov     ax,3d02h
                lea     dx,[bp+base_name]
                int     21h
                jc      base_not_fnd
                xchg    bx,ax

                mov     ax,4202h
                sub     cx,cx
                cwd
                push    ax cx dx
                int     21h

                cmp     ax,(base_end-base_start)
                jg      base_too_big

                pop     dx cx ax
                dec     ax
                dec     ax
                int     21h

                mov     ah,3fh
                mov     cx,(base_end-base_start)
                lea     dx,[bp+base_start]
                int     21h

                push    ax
                mov     ah,3eh
                int     21h
                pop     ax
                xchg    cx,ax
                lea     si,[bp+id_string]
                push    si
                mov     ax,word ptr [bp+xor_key]
                call    decrypt_code

                lea     si,[bp+swpr_version]
                pop     di
                mov     cx,3
                cld
                repe    cmpsb
                jnz     base_er_ver

                lea     dx,[bp+buffer]
                mov     word ptr [bp+buffer_loc],dx
                lea     dx,[bp+kernel]
                mov     word ptr [bp+kernel_offset],dx
                lea     dx,[bp+decryptor]
                mov     word ptr [bp+decryptor_loc],dx
                jmp     check_mem
;               jmp     file_search

 base_too_big:  pop     ax
                pop     ax
                pop     ax

                mov     ah,3eh
                int     21h

                lea     si,[bp+language]
                add     si,[bp+msg_base_too_big]
                call    print_string
                jmp     end_of_work

 base_er_ver:   lea     si,[bp+language]
                add     si,[bp+msg_base_er_ver]
                call    print_string
                jmp     exit_mes

 base_not_fnd:  lea     si,[bp+language]
                add     si,[bp+msg_base_not_found]
                call    print_string
                jmp     end_of_work

 check_mem:     lea     si,[bp+language]
                add     si,[bp+msg_check_memory]
                call    print_string

                push    ax cx dx bx di si sp bp
                mov     byte ptr [bp+check_what],0
                mov     byte ptr [bp+need_ext],'T'
                call    check_file
                pop     bp sp si di bx dx cx ax
                call    show_nul

 file_search:   mov     ah,19h
                int     21h
                add     al,61h
                mov     byte ptr [bp+original_path],al
           
                mov     ah,47h
                sub     dx,dx
                lea     si,[bp+original_path+3]
                int     21h

                mov     dl,byte ptr [bp+command_line]

                cmp     dl,'A'
                jb      lower
                cmp     dl,'Z'
                ja      lower
                sub     dl,41h
                jmp     set_disk

 disk_error:    jmp     cmnd_line_er+3

 lower:         cmp     dl,'a'
                jb      disk_error
                cmp     dl,'z'
                ja      disk_error
                sub     dl,61h

 set_disk:      mov     ah,0eh
                int     21h

                mov     cx,97
                lea     si,[bp+command_line+2]
                push    si
 search_end_lp: cmp     byte ptr [si],0dh
                jz      end_found
                inc     si
                loop    search_end_lp
                jmp     set_catalog

 end_found:     mov     byte ptr [si],0
                cmp     cx,96
                jz      set_catalog
                cmp     byte ptr [si-1],'\'
                jnz     set_catalog
                mov     byte ptr [si-1],0

 set_catalog:   pop     dx
                mov     ah,3bh
                int     21h
                jc      disk_error
; 
;  check for boot or mbr viruses on drive
;
 check_boot:    lea     si,[bp+language]
                add     si,[bp+msg_check_boot]
                call    print_string

                lea     si,[bp+msg_check_boot_2]

                mov     ah,19h
                int     21h

                add     byte ptr [si+1],al

                call    print_string

                push    ax cx dx bx di si sp bp
                mov     byte ptr [bp+check_what],1
                mov     byte ptr [bp+need_ext],'M'
                call    check_file
                pop     bp sp si di bx dx cx ax
                call    show_nul

 search:        call    search_files

 end_of_work:   lea     si,[bp+original_path]
                call    set_dir

 handle_rep:    call    report

                mov     bx,word ptr [bp+report_handle]
                mov     ah,3eh
                int     21h
                mov     byte ptr [bp+report_q],000h

 exit_mes:      lea     si,[bp+language]
                add     si,[bp+msg_press_enter]
                call    print_string

 get_exit_key:  sub     ax,ax
                int     16h
                cmp     ax,1c0dh
                jnz     get_exit_key

                mov     ax,4c00h
                int     21h
;
; DEC16OUT
;
 _dec16out:     push   ax cx bx bp di
                sub    cx,cx                    ; Initialize the counter
                lea    di,[bp+buffer_16]        ; Point to the buffer

 _dec16out1:    push   cx                       ; Save CX
                mov    ax,dx                    ; Numerator
                sub    dx,dx                    ; Clear upper half
                mov    cx,10                    ; Divisor of 10
                div    cx                       ; Divide
                xchg   ax,dx                    ; Get quotient
                add    al,30h                   ; Add 30H
                mov    [di],al                  ; Put in buffer
                inc    di                       ; Next byte
                pop    cx                       ; Restore CX
                inc    cx                       ; Count the digit
                or     dx,dx                    ; Done?
                jnz    _dec16out1

 _dec16out2:    dec    di                       ; Back up through the buffer
                push   cx
                sub    ax,ax
                mov    al,[di]                  ; Get byte from buffer
                mov    word ptr [bp+buffer],ax
                lea    si,[bp+buffer]
                call   print_string
                pop    cx
                loop   _dec16out2
                pop    di bp bx cx ax
                ret                              ; Return
;
 check_com:     push    ax cx dx bx di si sp bp
                inc     word ptr [bp+scanned]
                mov     byte ptr [bp+check_what],1
                mov     byte ptr [bp+need_ext],'C'
                call    start_build
                call    check_file
                pop     bp sp si di bx dx cx ax
                ret

 check_exe:     push    ax cx dx bx di si sp bp
                inc     word ptr [bp+scanned]
                mov     byte ptr [bp+check_what],1
                mov     byte ptr [bp+need_ext],'E'
                call    start_build
                call    check_file
                pop     bp sp si di bx dx cx ax
                ret

 check_any:     push    ax cx dx bx di si sp bp
                inc     word ptr [bp+scanned]
                mov     byte ptr [bp+check_what],1
                mov     byte ptr [bp+need_ext],'A'
                call    start_build
                call    check_file
                pop     bp sp si di bx dx cx ax
                ret
;
; calculate_end - calculates end of string
;
; on start   si - string start
; on exit    ax - string size
;
 calculate_end: push    si
 calc_end_loop: cmp     byte ptr [si],0
                jz      found_str_end
                inc     si
                jmp     calc_end_loop
 found_str_end: mov     ax,si
                pop     si
                sub     ax,si
                ret
;
; display_l
;
 display_l:     push    ax
                mov     ah,0eh
                int     10h
                pop     ax
                cmp     byte ptr [bp+report_handle],'x'
                jnz     write_l_to
                ret

 write_l_to:    push    ax cx dx bx
                mov     byte ptr [bp+buffer_rep],al
                mov     ah,40h
                mov     bx,word ptr [bp+report_handle]
                mov     cx,1
                lea     dx,[bp+buffer_rep]
                int     21h
                pop     bx dx cx ax
                ret
;
; show_nul - next string
;
 show_nul:      push    ax
                mov     al,0dh
                call    display_l
                mov     al,0ah
                call    display_l
                pop     ax
                ret
;
; display_fn - display filename
;
 display_fn:    mov     ah,19h
                int     21h
                add     al,41h
                call    display_l
                int     10h
                mov     al,':'
                call    display_l

                mov     ah,47h
                sub     dx,dx
                lea     si,[bp+buffer]
                int     21h

                cmp     byte ptr [bp+buffer],00
                jz      display_path

                mov     al,'\'
                call    display_l

 display_path:  lea     si,[bp+buffer]
                call    print_string

                mov     al,'\'
                call    display_l

                lea     si,[bp+file_name]
                call    print_string

                lea     si,[bp+tire]
                call    print_string
                ret
;
; search_files
;
 search_files:  mov     ah,3bh
                int     21h

                sub     sp,44
                mov     dx,sp
                mov     si,dx
                add     si,1eh
                mov     ah,1ah
                int     21h

                mov     ah,4eh
                mov     cx,7
                lea     dx,[bp+file_mask]
 search_next:   int     21h
                jnc     check_files
                jmp     search_cat

 check_files:;  mov     word ptr [bp+temp_si],si
                mov     ah,1
                int     16h
                cmp     ax,011bh
                jnz     continue_chk
                jmp     end_of_work             ; end_proc

 continue_chk:  push    ax cx dx bx bp sp si di
                call    test_files
                pop     di si sp bp bx dx cx ax

 find_next:     mov     ah,4fh
                jmp     search_next

 search_cat:    mov     cx,16
                lea     dx,[bp+file_mask]
                mov     ah,4eh
                int     21h
                jc      end_proc

 check_cat:     test    byte ptr [si-9],16
                jz      fnext_cat
                cmp     byte ptr [si],'.'
                jz      fnext_cat
                push    ax cx dx bx bp sp si di
                mov     dx,si
                call    search_files
                mov     ah,3bh
                lea     dx,[bp+old]
                int     21h
                pop     di si sp bp bx dx cx ax
                mov     ah,1ah
                lea     dx,[si-1eh]
                int     21h

 fnext_cat:     mov     ah,4fh
                int     21h
                jnc     check_cat

 end_proc:      add     sp,44
                ret
;
 test_files:    mov     ah,2fh
                int     21h

                push    ds ds
                mov     ax,es
                mov     dx,ds
                mov     ds,ax
                mov     es,dx

                lea     di,[bp+file_name]
                lea     si,[bx+1eh]
                mov     cx,13
                cld
                rep     movsb
                pop     ds es
 
                lea     si,[bp+file_name]
                call    calculate_end                 
                add     si,ax
                sub     si,3
                push    si

 check_com_ext: lea     di,[bp+com_ext]
                mov     cx,3
                cld
                repe    cmpsb
                pop     si
                jz      if_com_exe

 check_exe_ext: lea     di,[bp+exe_ext]
                mov     cx,3
                cld
                repe    cmpsb
                jnz     open_file

 if_com_exe:    call    save_attr

                mov     ax,3d02h
                lea     dx,[bp+file_name]
                int     21h
                jnc     file_hndl_ce
                call    restore_attr
                ret

 file_hndl_ce:  xchg    bx,ax
                mov     ah,3fh
                mov     cx,2
                lea     dx,[bp+buffer]
                int     21h

                mov     si,dx
                cmp     word ptr [si],'ZM'
                jz      exe_file
 com_file:      mov     byte ptr [bp+file_type],'C'
                jmp     display_fname

 open_file:     mov     ax,4300h
                lea     dx,[bp+file_name]
                int     21h
                mov     word ptr [bp+temp_attr],ax

                mov     ax,4301h
                sub     cx,cx
                int     21h

                call    save_attr
                mov     ax,3d02h
                lea     dx,[bp+file_name]
                int     21h
                jnc     file_handle
                call    restore_attr
                ret

 file_handle:   xchg    bx,ax
                mov     ah,3fh
                mov     cx,2
                lea     dx,[bp+buffer]
                int     21h

                mov     si,dx
                cmp     word ptr [si],'ZM'
                jz      exe_file

                mov     byte ptr [bp+file_type],'A'
                jmp     display_fname

 exe_file:      mov     byte ptr [bp+file_type],'E'
                jmp     display_fname
 
 display_fname: call    display_fn

                cmp     byte ptr [bp+file_type],'E'
                jz      j_to_exe
                cmp     byte ptr [bp+file_type],'A'
                jz      j_to_any

                call    check_com
                mov     ah,3eh
                int     21h
                call    restore_attr
                ret

 j_to_exe:      call    check_exe
                mov     ah,3eh
                int     21h
                call    restore_attr
                ret

 j_to_any:      call    check_any
                mov     ah,3eh
                int     21h
                call    restore_attr
                ret
;
;-              !!!     -
 display_info:  lea     si,[bp+info]
                call    print_string

                lea     si,[bp+loaded]
                call    print_string
                ret
;-              !!!     -
;---------------------------------------------------------------------------!!!
 start_build:   cmp     byte ptr [bp+deep_scan],000h
                jz      check_deep
                ret

 check_deep:    mov     al,byte ptr [bp+need_ext]
                cmp     al,'C'
                jz      poly_com
                cmp     al,'E'
                jz      poly_exe
                ret
;               jmp     polymorph

 poly_com:      call    com_entry
                jmp     polymorph
 poly_exe:      call    exe_entry

 polymorph:     call    build_dec
                ret
;
 include                base.inc
 include                procs.inc
 include                kernel.inc
 include                builder\builder.inc
;
 ends
;
; data segment
;
 dataseg
 info                   db 13,10
                        db 'the Sweeper '
 swpr_version           db '012'
                        db '/beta for dos (c) 2000 by C. Thomas Hawell Computing',13,10,13,10,0
;skobka                 db '[',0,']',0
 no_language            db 'No language file, please run Setup.Exe',13,10
                        db '  몮 䠩,   Setup.Exe',13,10,0
 msg_check_boot_2       db ' A - ',0
 loaded                 db 0
 scanned                dw 0
 infected               dw 0
 cleaned                dw 0
 deleted                dw 0
 possibly               dw 0
 com_ext                db 'COM'
 exe_ext                db 'EXE'
 cfg_name               db 'sweeper.cfg',0
 base_name              db 'sweeper.dat',0
 sweeper_lng            db 'sweeper.lng',0
 tire                   db ' - ',0
 file_mask              db '*.*',0 
 old                    db '..',0
 check_what             db 0
 report_handle          db "xx"
 temp_attr              dw ?
 end_time               db 3 dup (?)            ; ६ 砭 ஢ન
 start_time             db 3 dup (?)            ; ६ 砫 ஢ન
;
 cfg_start      label   byte  
 testing                db ?
 deep_scan              db ?
 report_q               db ?
 report_how             db ?
 report_fname           db 13 dup (?)
 cfg_end        label   byte
;
 language:              db 5 dup (?)
 msg_scanned            dw ?
 msg_infected           dw ?
 msg_cleaned            dw ?
 msg_deleted            dw ?
 msg_mod                dw ?
 msg_press_enter        dw ?
 msg_ill                dw ?
 msg_cured              dw ?
 msg_healthy            dw ?
 msg_not_cured          dw ?
 msg_command_parameters dw ?
 msg_cfg_not_fnd        dw ?
 msg_base_too_big       dw ?
 msg_base_not_found     dw ?
 msg_possibly           dw ?
 msg_base_er_ver        dw ?
 msg_crypted_vir        dw ?
 msg_check_memory       dw ?
 msg_check_boot         dw ?
 msg_time               dw ?
 text                   db (1000-(text-language)) dup (?)
;
 need_ext               db ?
 temp_si                dw ?
 file_type              db ?
 original_path          db 73 dup (?)
 file_name              db 13 dup (?)
 command_line           db 100 dup (?)
 buffer_rep             db ?
;
 base_start     label   byte
 xor_key                dw ?
 id_string              db 3 dup (?)
 buffer_loc             dw ?
 decryptor_loc          dw ?
;
 kernel_offset          dw ?                    ; ᯮ ୥
 crypted_code_size      dw ?                    ; ࠧ ஢ 
;
 viruses_list           dw ?
 entries_list           dw ?
 base_data              db 10000 dup (?)
 base_end       label   byte
;
 buffer_16              db 10 dup (?)
 buffer_for_sig         db 100 dup (?)
;
 read_pointer           dw ?
 write_pointer          dw ?
 high_border            dw ?
 loop_first             db 20 dup (?)
 loop_first_size        dw ?
 cycle_type             db ?
 counter_reg            db ?
 decryptor              db 1000 dup (?)
 sot                    db 260 dup (?)          ;   -
;
 buffer                 db 35000 dup (?)
 ends
;
                end     start
