.model tiny
.code
 org   256

 start:         mov     ax,3d02h
                jmp     jump

 file_name              db 'prinz_~1.vbs',0

 jump:          mov     dx,offset file_name
                int     21h
                jc      error
                xchg    bx,ax

                mov     ah,3fh
                mov     cx,30000
                mov     dx,offset buffer
                int     21h

                push    ax dx
                mov     ah,3eh
                int     21h
                pop     si cx

                mov    cx,20
 loop_1:        push   cx si
                sub    cx,cx
 vbs_srch_end:  cmp    word ptr [si],0a0dh      ; ᫨  1310,   -
                jz     found_end                ;  ப
                inc    si                       ; ᫨ , 㢥稬 ᨬ
                inc    cx                       ; 㢥稬 ࠧ ப
                jmp    vbs_srch_end             ; 饬  ப
 found_end:     inc    cx                       ; 㢥稬 ࠧ ப (13)
                inc    cx                       ; 㢥稬 ࠧ ப (10)
                xchg   cx,di                    ; ࠧ ப  di
                pop    si                       ; ᯮ 砫 ப
                push   di
                call   calculate_crc            ; 塞 crc 16&32
                call   string
                pop    di
                xchg   ax,dx                    ; crc16  dx
                add    si,di
                int    3
                pop    cx
;               sub    cx,di
                loop   loop_1

 error:         int     20h

 string:        xchg    dx,ax
                call    dec16out

                mov     al,13
                call    stdout
                mov     al,10
                call    stdout
                ret
;
; calculate crc 16&32
;
; on start: ds:si - data
;              di - size of data
; return  : cx:dx - crc32
;              ax - crc16
;
 calculate_crc: cld
                push   cx dx bx si
                mov    cx,-1
                mov    dx,cx

 next_byte:     sub    ax,ax
                sub    bx,bx
                lodsb
                xor    al,cl
                mov    cl,ch
                mov    ch,dl
                mov    dl,dh
                mov    dh,8

 next_bit:      shr    bx,1
                rcr    ax,1
                jnc    no_carry
                xor    ax,8320h
                xor    bx,0edb8h

 no_carry:      dec    dh
                jnz    next_bit
                xor    cx,ax
                sub    dx,bx
                dec    di
                jnz    next_byte
                not    dx
                not    cx
                mov    ax,dx
                ror    ax,cl
                add    ax,cx
                pop    si bx dx cx
                ret
;
; STDOUT
;
 stdout:        push   dx                       ; Save register
                mov    dl,al                    ; In DL for DOS call
                mov    ah,2                     ; Standard output
                int    21h                      ; DOS call
                inc    bp
                pop    dx                       ; Restore register
                ret                             ; Return
;
; DEC16OUT
;
 dec16out:      push   ax cx bx bp di
                sub    cx,cx                    ; Initialize the counter
                lea    di,[bp+buffer_16]        ; Point to the buffer

 dec16out1:     push   cx                       ; Save CX
                mov    ax,dx                    ; Numerator
                sub    dx,dx                    ; Clear upper half
                mov    cx,10                    ; Divisor of 10
                div    cx                       ; Divide
                xchg   ax,dx                    ; Get quotient
                add    al,30h                   ; Add 30H
                mov    [di],al                  ; Put in buffer
                inc    di                       ; Next byte
                pop    cx                       ; Restore CX
                inc    cx                       ; Count the digit
                or     dx,dx                    ; Done?
                jnz    dec16out1

 _dec16out2:    dec    di                       ; Back up through the buffer
                mov    al,[di]                  ; Get byte from buffer
                call   stdout                   ; Send it out
                loop   _dec16out2
                pop    di bp bx cx ax
                ret                             ; Return
;
 buffer_16             db 11 dup (?)
 buffer                db 30000 dup (?)
;
                end    start
